// Subdesign C-One
// C-One reconfigurable computer
// (c) Tobix Gubener 2004
// All rights reserved.
// only for use in the C-One-Projekt!

#include <stdio.h>
#include <string.h>
#include <fstream.h>
#include <stdlib.h>
#include <direct.h>
#include <io.h>
#include<iomanip>

void ShowSyntax (void) {
    cout << "raw2cone - Tobias Gubener, Juli 2005" << endl;
    cout << "Usage: raw2cone filename" << endl;
}

// hardcore exit
void hcExit(long fehlerNr) 
{
    fprintf(stderr, "Hardcore exit, any error: %ld\n", fehlerNr);
//    (_chdir(old_dir));
    exit(1);
}




int main(int argc, char **argv) {
    if (argc != 2) {
    	ShowSyntax();
    	return(3);
    }
    
    struct _finddata_t fd;
    long hFile;
	char *p, *q, r, g, b, h ,l, j;  

    hFile = _findfirst(argv[1], &fd);
    if (hFile == -1L) return 0;
    

    p = (char *)malloc(fd.size+1);
    if (! p) hcExit(5);


	ofstream out;

	out.open("cone.raw",ofstream::binary|ofstream::out|ofstream::trunc);

	ifstream in(fd.name,ios::binary|ios::nocreate);
    if (! in) hcExit(10);
    
    in.read(p, fd.size);
	q = p;
	j=0;
	g=0;
	b=0;

	for (long i=0;i<fd.size;i++)
	{
//		q=&p[i];//+0x2000];
//		printf("%c",*q);
//		printf("%c",*++q);
		r=g;
		g=b;
		b=*q++;
		if (++j==3)
		{	
			h=(b & 0xf8)| ((g>>5) & 0x7);
			l=((g<<3) & 0xe0)|((r>>3) &0x1f);
			out.put(h);
			out.put(l);
			j=0;
		}
	}
//	out.flush();
	out.close();
	free(p);
    _findclose(hFile);
	return 0;
}
    
